#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "yacc.y"
#include <stdio.h>
#include <string.h>

#include "figbuild.h"
#include "aux.h"

#define Float	double

/* $Header: /home/apian/r/gen/figbuild/RCS/yacc.y,v 1.5 2000/11/07 20:44:42 apian Exp apian $ */

char yyfilename[BUFSIZ];			/* Input filename */

extern FILE *yyin;				/* input file pointer */
extern int yylineno;				/* Current line # in file */

extern	float	scale;
extern char	*strsave();
extern	float	origin[];
extern	int	debug;

static	v_segments	*vs;		/* space for new segment */

static float	gnddef=0.0;			/* global defaults */
static char	ceildef[1024]="\0", floordef[1024]="\0";

#line 28 "yacc.y"
typedef union {
	char *c;
	int i;
	Float d;
} YYSTYPE;
#line 44 "y.tab.c"
#define tFLOAT 257
#define tSTRING 258
#define tTILT 259
#define tDEFSEG 260
#define tENDSEG 261
#define tFLOORMAT 262
#define tCEILMAT 263
#define tFILL 264
#define t2DSCALE 265
#define tNOFILL 266
#define tEXTRUDE 267
#define tBOX 268
#define tCYL 269
#define tGROUND 270
#define tORIGIN 271
#define UMINUS 272
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    2,    2,    4,    4,    4,    4,    4,    3,
    5,    7,    6,    6,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    1,    1,    1,
};
short yylen[] = {                                         2,
    0,    2,    1,    1,    2,    2,    2,    2,    3,    3,
    2,    1,    0,    2,    2,    2,    2,    2,    2,    1,
    1,    5,    4,    1,    2,    2,
};
short yydefred[] = {                                      1,
    0,   24,    0,    0,    0,    0,    0,    0,    0,    0,
    2,    3,    4,   13,   11,    5,    6,    8,    0,   26,
   25,    7,    0,    9,    0,   12,    0,    0,   21,   20,
    0,    0,   10,   14,   16,   17,   18,    0,    0,   15,
   19,    0,    0,    0,   23,   22,
};
short yydgoto[] = {                                       1,
   10,   11,   12,   13,   14,   23,   33,   34,
};
short yysindex[] = {                                      0,
  -43,    0, -257, -251, -250, -248, -247, -245, -243, -253,
    0,    0,    0,    0,    0,    0,    0,    0, -239,    0,
    0,    0,  -32,    0, -240,    0, -238, -237,    0,    0,
 -263, -255,    0,    0,    0,    0,    0, -236, -235,    0,
    0, -233, -232, -231,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -254,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    4,    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 235
short yytable[] = {                                       8,
   15,    9,   40,   24,   38,   39,   16,   17,   18,   19,
    8,   20,    9,   21,   41,   24,   22,   24,   35,   36,
   37,   42,   43,   44,   45,   46,   32,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    2,    0,    0,    3,    0,    4,    5,
    0,    6,    0,    0,   25,    0,    0,    7,   26,   27,
   28,   29,    0,   30,   31,
};
short yycheck[] = {                                      43,
  258,   45,  258,  258,  268,  269,  258,  258,  257,  257,
   43,  257,   45,  257,  270,  270,  270,  257,  259,  258,
  258,  258,  258,  257,  257,  257,   23,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,   -1,  260,   -1,  262,  263,
   -1,  265,   -1,   -1,  257,   -1,   -1,  271,  261,  262,
  263,  264,   -1,  266,  267,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 272
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'%'",0,0,0,0,"'*'","'+'",0,"'-'",0,"'/'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'^'",0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"tFLOAT",
"tSTRING","tTILT","tDEFSEG","tENDSEG","tFLOORMAT","tCEILMAT","tFILL","t2DSCALE",
"tNOFILL","tEXTRUDE","tBOX","tCYL","tGROUND","tORIGIN","UMINUS",
};
char *yyrule[] = {
"$accept : Items",
"Items :",
"Items : Items Item",
"Item : DefineSegment",
"Item : Globals",
"Globals : tFLOORMAT tSTRING",
"Globals : tCEILMAT tSTRING",
"Globals : Float tGROUND",
"Globals : t2DSCALE tFLOAT",
"Globals : tORIGIN tFLOAT tFLOAT",
"DefineSegment : SegStart SegDescs SegEnd",
"SegStart : tDEFSEG tSTRING",
"SegEnd : tENDSEG",
"SegDescs :",
"SegDescs : SegDescs SegDesc",
"SegDesc : Float tSTRING",
"SegDesc : tFLOAT tTILT",
"SegDesc : tFLOORMAT tSTRING",
"SegDesc : tCEILMAT tSTRING",
"SegDesc : Float tGROUND",
"SegDesc : tNOFILL",
"SegDesc : tFILL",
"SegDesc : tEXTRUDE tBOX tSTRING tFLOAT tFLOAT",
"SegDesc : tEXTRUDE tCYL tSTRING tFLOAT",
"Float : tFLOAT",
"Float : '-' tFLOAT",
"Float : '+' tFLOAT",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 152 "yacc.y"
/*
 * Issue error message containing filename and line number, and exit.
 */
/*VARARGS1*/
yyerror(s, pat1, pat2)
char *s, *pat1, *pat2;
{
	fprintf(stderr,"Error: %s: line %d: ", yyfilename, yylineno);
	fprintf(stderr, s, pat1, pat2);
	if (*s && s[strlen(s) -1] != '\n')
		/* YACC doesn't put newlines on error messages. */
		fprintf(stderr,"\n");	
	fflush(stderr);
	exit(1);
}

#line 238 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 51 "yacc.y"
{
		  strcpy( floordef, yyvsp[0].c );
		}
break;
case 6:
#line 55 "yacc.y"
{
		  strcpy( ceildef, yyvsp[0].c );
		}
break;
case 7:
#line 59 "yacc.y"
{
		  gnddef=yyvsp[-1].d;
		}
break;
case 8:
#line 63 "yacc.y"
{
		  scale=yyvsp[0].d;
		}
break;
case 9:
#line 67 "yacc.y"
{
		  origin[0]=yyvsp[-1].d;
		  origin[1]=yyvsp[0].d;
		}
break;
case 11:
#line 74 "yacc.y"
{
		  vs = v_segs_new();
		  vs->gnd= gnddef;
		  vs->filled= 0x01;
		  strncpy( vs->floormat, floordef, STRING_MAX);
		  strncpy( vs->ceilmat, ceildef, STRING_MAX);
		  vs->name = strsave(yyvsp[0].c) ;
		  vs->max = 0;
	 	  vs->ex=NULL;
		}
break;
case 12:
#line 86 "yacc.y"
{
#ifdef DEBUG
		fprintf(stderr,"segment \"%s\" completed with %d vsegs:\n",
				vs->name, vs->max );
		fprintf(stderr,"floor, ceil: \"%s\",\"%s\"\n", vs->floormat, vs->ceilmat );
#endif
		}
break;
case 15:
#line 99 "yacc.y"
{
		  vs->segs[vs->max].height= yyvsp[-1].d;
		  vs->segs[vs->max].name  = strsave( yyvsp[0].c );
		  vs->segs[vs->max].tilt  = 0.0;
		  vs->max++;
		}
break;
case 16:
#line 106 "yacc.y"
{
		  if(vs->max>1) vs->segs[vs->max-1].tilt = yyvsp[-1].d;
		}
break;
case 17:
#line 110 "yacc.y"
{
		  strncpy( vs->floormat, yyvsp[0].c, STRING_MAX);
		}
break;
case 18:
#line 114 "yacc.y"
{
		  strncpy( vs->ceilmat, yyvsp[0].c, STRING_MAX);
		}
break;
case 19:
#line 118 "yacc.y"
{
		  vs->gnd=yyvsp[-1].d;
		}
break;
case 20:
#line 122 "yacc.y"
{
		  vs->filled= 0x00;
		}
break;
case 21:
#line 126 "yacc.y"
{
		  vs->filled= 0x11;
		}
break;
case 22:
#line 130 "yacc.y"
{
		  vs->ex = (extrusion_data *) tmalloc(sizeof(extrusion_data));
		  vs->ex->mode = EXTRUSION_BOX;
		  strncpy( vs->ex->mat, yyvsp[-2].c, STRING_MAX);
		  vs->ex->scale_h = yyvsp[-1].d;
		  vs->ex->scale_v = yyvsp[0].d;
		}
break;
case 23:
#line 138 "yacc.y"
{
		  vs->ex = (extrusion_data *) tmalloc(sizeof(extrusion_data));
		  vs->ex->mode = EXTRUSION_CYL;
		  strncpy( vs->ex->mat, yyvsp[-1].c, STRING_MAX);
		  vs->ex->scale_h = yyvsp[0].d;
		}
break;
case 25:
#line 147 "yacc.y"
{ yyval.d = -yyvsp[0].d; }
break;
case 26:
#line 149 "yacc.y"
{ yyval.d = yyvsp[0].d; }
break;
#line 505 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
